// Languages.java
// $Id: Languages.java,v 1.3 2000/08/17 15:07:27 bmahe Exp $
// (c) COPYRIGHT MIT, INRIA and Keio, 1999.
// Please first read the full copyright statement in file COPYRIGHT.html

package org.w3c.jwput.gui;

import java.util.Hashtable;

/**
 * Utilities about languages
 * @version $Revision: 1.3 $
 * @author  Benot Mah (bmahe@w3.org)
 */
public class Languages {

    public static final String languages_array[] = {
	"(Afan) Oromo [om]","Abkhazian [ab]","Afar [aa]",
	"Afrikaans [af]","Albanian [sq]","Amharic [am]",
	"Arabic [ar]","Armenian [hy]","Assamese [as]",
	"Aymara [ay]","Azerbaijani [az]","Bashkir [ba]",
	"Basque [eu]","Bengali, Bangla [bn]","Bhutani [dz]",
	"Bihari [bh]","Bislama [bi]","Breton [br]",
	"Bulgarian [bg]","Burmese [my]","Byelorussian [be]",
	"Cambodian [km]","Catalan [ca]","Chinese [zh]",
	"Corsican [co]","Croatian [hr]","Czech [cs]",
	"Danish [da]","Dutch [nl]","English [en]",
	"Esperanto [eo]","Estonian [et]","Faeroese [fo]",
	"Fiji [fj]","Finnish [fi]","French [fr]",
	"Frisian [fy]","Galician [gl]","Georgian [ka]",
	"German [de]","Greek [el]","Greenlandic [kl]",
	"Guarani [gn]","Gujarati [gu]","Hausa [ha]",
	"Hebrew [iw]","Hindi [hi]","Hungarian [hu]",
	"Icelandic [is]","Indonesian [in]","Interlingua [ia]",
	"Interlingue [ie]","Inupiak [ik]","Irish [ga]",
	"Italian [it]","Japanese [ja]","Javanese [jw]",
	"Kannada [kn]","Kashmiri [ks]","Kazakh [kk]",
	"Kinyarwanda [rw]","Kirghiz [ky]","Kirundi [rn]",
	"Korean [ko]","Kurdish [ku]","Laothian [lo]",
	"Latin [la]","Latvian, Lettish [lv]","Lingala [ln]",
	"Lithuanian [lt]","Macedonian [mk]","Malagasy [mg]",
	"Malay [ms]","Malayalam [ml]","Maltese [mt]",
	"Maori [mi]","Marathi [mr]","Moldavian [mo]",
	"Mongolian [mn]","Nauru [na]","Nepali [ne]",
	"Norwegian [no]","Occitan [oc]","Oriya [or]",
	"Pashto, Pushto [ps]","Persian [fa]","Polish [pl]",
	"Portuguese [pt]","Punjabi [pa]","Quechua [qu]",
	"Rhaeto-Romance [rm]","Romanian [ro]","Russian [ru]",
	"Samoan [sm]","Sangro [sg]","Sanskrit [sa]",
	"Scots Gaelic [gd]","Serbian [sr]","Serbo-Croatian [sh]",
	"Sesotho [st]","Setswana [tn]","Shona [sn]",
	"Sindhi [sd]","Singhalese [si]","Siswati [ss]",
	"Slovak [sk]","Slovenian [sl]","Somali [so]",
	"Spanish [es]","Sundanese [su]","Swahili [sw]",
	"Swedish [sv]","Tagalog [tl]","Tajik [tg]",
	"Tamil [ta]","Tatar [tt]","Tegulu [te]",
	"Thai [th]","Tibetan [bo]","Tigrinya [ti]",
	"Tonga [to]","Tsonga [ts]","Turkish [tr]",
	"Turkmen [tk]","Twi [tw]","Ukrainian [uk]",
	"Urdu [ur]","Uzbek [uz]","Vietnamese [vi]",
	"Volapuk [vo]","Welsh [cy]","Wolof [wo]",
	"Xhosa [xh]","Yiddish [ji]","Yoruba [yo]",
	"Zulu [zu]" 
    };

    public static Hashtable languages = null;

    public static String getLanguage(String abbrev) {
	String lang = (String)languages.get(abbrev);
	if (lang == null)
	    lang = "Uknown ["+abbrev+"]";
	return lang;
    }

    public static String getAbbrev(String lang) {
	int    idx  = lang.indexOf('[')+1;
	int    idx2 = lang.indexOf(']');
	if ((idx == -1) || (idx2 == -1))
	    return lang;
	return lang.substring(idx, idx2);
    }

    static {
	int len = languages_array.length;
	languages = new Hashtable(len);
	for (int i = 0 ; i < len ; i++)
	    languages.put(getAbbrev(languages_array[i]), languages_array[i]);
    }

}
