// BrowseListener.java
// $Id: BrowseListener.java,v 1.9 2000/08/17 15:07:27 bmahe Exp $
// (c) COPYRIGHT MIT, INRIA and Keio, 1999.
// Please first read the full copyright statement in file COPYRIGHT.html

package org.w3c.jwput.gui;

import java.io.File;
import java.util.Properties;

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

import javax.swing.JComboBox;
import javax.swing.JComponent;
import javax.swing.JFileChooser;

/**
 * Link an History Object to FileChooser
 * @version $Revision: 1.9 $
 * @author  Benot Mah (bmahe@w3.org)
 */
public class BrowseListener implements ActionListener {

    History      history  = null;
    JFileChooser chooser  = null;
    File         current  = null;
    Properties   props    = null;
    String       property = null;

    public void actionPerformed(ActionEvent e) {
	if (chooser == null) {
	    if (current == null) {
		chooser = new JFileChooser();
	    } else {
		chooser = new JFileChooser(current);
	    }
	    chooser.setMultiSelectionEnabled(true);
	    chooser.setFileSelectionMode(JFileChooser.FILES_AND_DIRECTORIES);
	}
	int returnVal = chooser.showOpenDialog((JComponent)e.getSource());
	updateCurrentDir(chooser.getCurrentDirectory());

	if (returnVal ==  JFileChooser.APPROVE_OPTION) {
	    File selected[] = chooser.getSelectedFiles();
	    int len = selected.length;
	    if (len > 1) {
		StringBuffer buffer = new StringBuffer();
		for (int i = 0 ; i < selected.length ; i++) {
		    if (i != 0)
			buffer.append("|");
		    buffer.append(selected[i].getAbsolutePath());
		}
		if (history != null)
		    history.add(buffer.toString());
	    } else if (history != null) {
		history.add(chooser.getSelectedFile().getAbsolutePath());
	    }
	}
    }

    protected void updateCurrentDir(File file) {
	if (! file.isDirectory()) {
	    file = file.getParentFile();
	}
	props.put(property, file.getAbsolutePath());
    }

    protected BrowseListener(History history, 
			     Properties props,
			     String property) 
    {
	this.history  = history;
	this.props    = props;
	this.property = property;

	String dir    = (String)props.get(property);
	if (dir != null) {
	    this.current = new File(dir);
	}
    }

}
