// SelectionEventSupport.java
// $Id: SelectionEventSupport.java,v 1.2 2000/12/14 16:04:24 bmahe Exp $
// (c) COPYRIGHT MIT, INRIA and Keio, 2000.
// Please first read the full copyright statement in file COPYRIGHT.html

package org.w3c.jwput.gui.webdav.event;

import java.util.*;

/**
 * @version $Revision: 1.2 $
 * @author  Benot Mah (bmahe@w3.org)
 */
public class SelectionEventSupport {

    protected Vector selectionListeners = null;

    public synchronized void addSelectionListener(SelectionListener listener) {
	selectionListeners.addElement(listener);
    }

    public synchronized 
	void removeSelectionListener(SelectionListener listener) 
    {
	selectionListeners.removeElement(listener);
    }

    public void fireSelectionEvent(SelectionEvent ev) {
	for(int i = 0; i < selectionListeners.size(); i++) {
	    SelectionListener listener = 
		(SelectionListener)selectionListeners.elementAt(i);
	    listener.selectionChanged(ev);
	}
    }

    public SelectionEventSupport() { 
	selectionListeners = new Vector();
    }
    
}
